// vim: et:ts=4:sw=4:sts=4:ft=javascript

/*@
Ox.Layer <o> Background layer for dialogs and menus
    (options, self) -> <o> Layer
    options <o> Options
        type <s|'dialog'> Layer type ('dialog' or 'menu')
    self <o> Shared private variable
@*/

Ox.Layer = function(options, self) {

    self = self || {};
    var that = Ox.Element({}, self)
        .defaults({
            type: 'dialog'
        })
        .options(options || {})
        .addClass('OxLayer Ox' + Ox.toTitleCase(self.options.type) + 'Layer')
        .bind(self.options.type == 'dialog' ? {
            mousedown: mousedown,
        } : {
            click: click
        });

    function click() {
        that.triggerEvent('click').removeElement();
    }

    function mousedown() {
        that.stop().animate({opacity: 0.5}, 0);
    }

    function mouseup() {
        that.stop().animate({opacity: 0}, 250);
    }

    that.hide = function() {
        if (self.options.type == 'dialog') {
            Ox.UI.$window.unbind({mouseup: mouseup});
        }
        that.removeElement();
    };

    that.show = function() {
        if (self.options.type == 'dialog') {
            Ox.UI.$window.bind({mouseup: mouseup});
        }
        that.appendTo(Ox.UI.$body);
        return that;
    }

    return that;

}